/*****************************************************************************
	X-GREP

	xgrep_main.c

	Copyright (C) 2016 ARKTRAN,INC.
	Author: Seikoh Tanaka <tanaka@arktran.com>

	2016/06/04	ver1.0
	2016/06/14	ver1.0.1 lbg[NpX̃nCp[NsɂȂsC

	{\[Xłmake邱Ƃ͂ł܂B

 *****************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifdef MINGW
#define _WIN32_IE		0x0400
#ifndef _WIN32_WINNT
# define _WIN32_WINNT		0x0502	/* KEY_WOW64_64KEY */
#endif
#endif

//#define	XGREP_MULTI_THREAD	/* 2016/06/06  J */

#define	IS_ON_MEMORY

#include <windows.h>
#include <process.h>
#include <shlobj.h>
#include <direct.h>
#include <tchar.h>
#include <io.h>

#include "aod_define.h"
#include "ark_inifile.h"
#include "ark_regexp.h"
#include "xgrep_resource.h"
#include "xls_api.h"
#include "pole.h"

#if defined(__MINGW32__)
 #undef  MAKEINTRESOURCE
 #define MAKEINTRESOURCE(i) ((LPSTR)((ULONG_PTR)(i)))
#endif


#define	XGREP_PRODUCT_NAME	"X-Grep"
#define	XGREP_MUTEX_NAME	XGREP_PRODUCT_NAME
#define	XGREP_WINDOW_TITLE	XGREP_PRODUCT_NAME
#define	XGREP_INI_PASSWORD	"ARKA"
#define	XGREP_INI_FILE		"X-Grep.ini"
#define	XGREP_2003WORKBOOK	"X-Grep2003.tmp"
#define	XGREP_RESULT_BOOK	"X-Grep.xlsx"

#define	XGREP_MAX_FILENAME	10
#define	XGREP_MAX_FIND		10000
#define	XGREP_MAX_THREAD	10

#define	XGREP_BUFFER_LEN	(4096*10)

#define	XGREP_TREAD_WAIT_MSEC	1

typedef struct _thread_pool {
	int		no;
	HANDLE		hThread;
} THREAD_POOL;

THREAD_POOL	ThreadPool[XGREP_MAX_THREAD];
int		Thread_ct = 0;
int		Thread_no = 0;
int		Max_thread = 4;
int		Is_kill = 0;

/* Option */
typedef struct _xgrep_option {
	int		thread_no;
	char		directory[PATH_LEN+1];
	char		path[PATH_LEN+1];
	char		work_directory[PATH_LEN+1];
	char		temp_directory[PATH_LEN+1];
	char		current_directory[PATH_LEN+1];
	char		tmp_workbook[PATH_LEN+1];
	char		output_path[PATH_LEN+1];
	char		list_path[PATH_LEN+1];
	int		is_output_excel;
	int		is_regular_expression;
	char		keyword[WORD_LEN+1];
	char		filenames[WORD_LEN+1];
	char		filename[XGREP_MAX_FILENAME][WORD_LEN+1];
	int		filename_ct;
	char		**pattern;
	int		pattern_ct;
	int		find_ct;
	XLS_BOOK	book;
} XGREP_OPTION;


/* Global */
XGREP_OPTION	Option, Init_option;			/* option */

int		GnCmdShow;				/* window mode */
HINSTANCE	GhInst;					/* instance handle */
HWND		GhWnd;					/* window handle */
HFONT		GhFont, GhFont2;			/* font handle */
HWND		GhBtn[4];				/* check box handle */
HWND		GhText[7];				/* edit handle */
HWND		GhChk[2];				/* check box handle */

HACCEL		GhAccel;				/* accelerators handle */
HDC		GhMain;					/* device handle */

char		szMainClass[] = "XGREP_MAIN";		/* window class */
char		szProgressClass[] = "XGREP_PROGRESS";	/* window class */
char		szWindowsTitle[] = XGREP_WINDOW_TITLE;	/* window name */

/* Function ProtoType */
int	xgrep_main(XGREP_OPTION *option);
unsigned __stdcall xgrep_find_book_main(void *arg);
unsigned __stdcall xgrep_find_book(void *arg);
unsigned __stdcall xgrep_grep_book_main(void *arg);
int	xgrep_grep_book(XGREP_OPTION *option);
int	xgrep_dump_2003WorkBook(char *xls_path, char *tmp_path);
int	xgrep_check_event(MSG *min_msg);
int	xgrep_init_option(XGREP_OPTION *option);
int	xgrep_is_update_option();
int	xgrep_parse_option(XGREP_OPTION *option);
int	xgrep_read_ini(char *ini_path);
int	xgrep_write_ini(char *ini_path);
int	xgrep_create_window();
int	xgrep_launch_excel(char *path);
int	xgrep_launch_notepad(char *path);
void	xgrep_run_thread(XGREP_OPTION *option);
void	xgrep_wait_thread();
int	xgrep_check_thread_pool();
int	xgrep_main_end();
BOOL	InitInstance(HINSTANCE GhInst, int nCmdShow);
LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
int	CALLBACK BrowseCallbackProc(HWND hWnd, UINT msg, LPARAM lParam, LPARAM lpData);
int	load_BMP(HWND hWnd, HDC hdc);
int	swap_mbspace(int charset, unsigned char *buffer);

/*---------------------------------------------------------------------------*
	ExcelubNgrep
 *---------------------------------------------------------------------------*/
int	xgrep_grep_book(

XGREP_OPTION	*option)
{
	int		i, ied, rc, sheet, row, clm, max_clm, length, is_match, break_flg;
	char		cell1[32], cell2[32], cell3[32], cell4[32], cell5[32];
	char		book_path[PATH_LEN+1], exe_path[PATH_LEN+1], temp_path[PATH_LEN+1], directory[PATH_LEN+1], property[256];
	char		arguments[WORD_LEN+1], message[WORD_LEN+1], sheet_name[WORD_LEN+1];
	char		value[XLS_CELL_UTF8_LEN+1];
	FILE		*fp;
	XLS_BOOK	bookr;

	/* ExcelubNI[v */
#ifdef IS_ON_MEMORY
	sprintf(arguments, "EXCEL=\"%s\" MODE=UNLOAD TEMP_WORKBOOK_PATH=\"%s\"", option->path, option->tmp_workbook);
#ifdef XGREP_MULTI_THREAD
	sprintf(arguments, "EXCEL=\"%s\" MODE=UNLOAD TEMP_WORKBOOK_PATH=\"%s\" THREAD=%d", option->path, option->tmp_workbook, option->thread_no);
#endif
#else
	sprintf(arguments, "EXCEL=\"%s\" MODE=UNLOAD READ_MEMORY=TRUE TEMP_WORKBOOK_PATH=\"%s\"", option->path, option->tmp_workbook);
#endif
	rc = AXLS_open_book(&bookr, arguments);
	switch (rc){
	case	AXLS_OK:
		break;
	default:
		return(RTN_ERROR);
	}

	/* fBNgpX擾 */
	strcpy(directory, option->path);
	length = strlen(directory);
	ied    = length - 1;
	for (i=0; i<length; i++){
		if (is_mbchar(DEFAULT_OS_CHARSET, directory[i], &i)){
			continue;
		}
		if (directory[i] == '\\'){
			ied = i;
		}
	}
	directory[ied] = 0x00;

	/* ΃pXϊ */
	if (option->path[0] != '\\' && option->path[1] != '\\' && option->path[1] != ':'){

		/* get current directory */
		GetModuleFileName(NULL, exe_path, PATH_LEN);

		length = strlen(exe_path);
		ied    = length - 1;
		for (i=0; i<length; i++){
			if (is_mbchar(DEFAULT_OS_CHARSET, exe_path[i], &i)){
				continue;
			}
			if (exe_path[i] == '\\'){
				ied = i;
			}
		}
		exe_path[ied] = 0x00;
		sprintf(book_path, "%s\\%s", exe_path, option->path);
		strcpy(temp_path, directory);
		sprintf(directory, "%s\\%s", exe_path, temp_path);
	} else {
		strcpy(book_path, option->path);
	}

	/* [v */
	break_flg = 0;
	for (sheet=0; sheet<bookr.sheet_ct; sheet++){

		/* JgV[gؑւăV[g擾 */
		if (AXLS_open_sheet2(&bookr, sheet) != AXLS_OK){
			continue;
		}
		strcpy(sheet_name, bookr.sheet[sheet].name);
		length = strlen(sheet_name);
		trans_charset(CHARSET_UTF8, DEFAULT_OS_CHARSET, sheet_name, &length);

		/* sJԂ */
		for (row=0; row<bookr.sheet[sheet].row_ct; row++){

			/* 󔒗𖳎邽߂̗񐔃JEg */
			max_clm = bookr.sheet[sheet].row[row].clm_ct;

			for (i=max_clm-1; i>0; i--){
				if (AXLS_cell_name(row+1, i+1, cell1)){
					continue;
				}
				if (AXLS_get_cell(&bookr, cell1, value, sizeof(value)-1, property, sizeof(property)-1) != AXLS_OK){
					continue;
				}
				if (value[0] != 0x00){
					max_clm = i+1;
					break;
				}
			}

			/* 񐔌JԂ */
			for (clm=0; clm<max_clm; clm++){

				/* Zl擾 */
				if (AXLS_cell_name(row+1, clm+1, cell1)){
					continue;
				}
				if (AXLS_get_cell(&bookr, cell1, value, sizeof(value)-1, property, sizeof(property)-1) != AXLS_OK){
					continue;
				}

				/* }b`O */
				is_match = IS_FALSE;
				length = strlen(value);
				for (i=0; i<option->pattern_ct; i++){
					if (option->is_regular_expression == IS_TRUE){
						/* K\}b`O */
						if (is_regexp_match(value, length, option->pattern[i], WORD_LEN) == IS_TRUE){
							is_match = IS_TRUE;
							break;
						}
					} else {
						/* }b`O */
						if (strstr(value, option->pattern[i])){
							is_match = IS_TRUE;
							break;
						}
					}
				}

				/* ʏo */
				if (is_match == IS_TRUE){

					option->find_ct++;		/* ʌCNg */

					if (option->is_output_excel == IS_TRUE){

						/* Exce\ */
#ifndef COMMAND_LINE
						sprintf(message, "%d", option->find_ct);
						SetWindowText(GhText[5], message);
#endif
						if (option->find_ct > XGREP_MAX_FIND){
#ifndef COMMAND_LINE
							sprintf(message, "ʂő匏(%d)ɓB܂B𒆒f܂B", XGREP_MAX_FIND);
							MessageBox(GhWnd, message, XGREP_PRODUCT_NAME, MB_TOPMOST|MB_ICONWARNING|MB_OK);
#endif
							break_flg = 1;	/* ftOON */
							break;
						}

						if (AXLS_cell_name(option->find_ct+1, 1, cell2)){
							continue;
						}
						if (AXLS_cell_name(option->find_ct+1, 2, cell3)){
							continue;
						}
						if (AXLS_cell_name(option->find_ct+1, 3, cell4)){
							continue;
						}
						if (AXLS_cell_name(option->find_ct+1, 4, cell5)){
							continue;
						}
						if (strlen(value) > 1000){
							value[1000] = 0x00;
						}
						sprintf(arguments, "%s=\"%s\" %s=\"%s\" %s=\"%s\" %s=\"%s\"", cell2, value, cell3, cell1, cell4, sheet_name, cell5, option->path);

						/* ʍso */
						rc = AXLS_put_values(&option->book, arguments);
						switch (rc){
						case	AXLS_OK:
							break;
						default:
							continue;
						}

						/* Zlւ̃nCp[Nݒ */
						rc = AXLS_book_hyperlink(&option->book, cell2, book_path, sheet_name, cell1);
						switch (rc){
						case	AXLS_OK:
							break;
						default:
							continue;
						}

						/* fBNgւ̃nCp[Nݒ */
						rc = AXLS_external_hyperlink(&option->book, cell5, directory);
						switch (rc){
						case	AXLS_OK:
							break;
						default:
							continue;
						}
					} else {
						/* eLXgO */
#ifdef COMMAND_LINE
						printf("[%s][%s][%s] %s\n", option->path, sheet_name, cell1, value);
#else
						if ((fp = fopen(option->output_path, "at")) != NULL){
							fprintf(fp, "[%s][%s][%s] %s\n", option->path, sheet_name, cell1, value);
							fclose(fp);
						}
#endif
					}
				}
			}
			if (break_flg) break;
		}
		if (break_flg) break;
	}
	/* ExcelubN */
	AXLS_close_book(&bookr, NULL);

	return(RTN_NORMAL);
}

/*---------------------------------------------------------------------------*
	ExcelubNXbhC
 *---------------------------------------------------------------------------*/
unsigned __stdcall xgrep_find_book_main(

void		*arg)		/* |C^ */
{
	XGREP_OPTION	*option = (XGREP_OPTION *)arg;

	strcpy(option->work_directory, option->directory);

	xgrep_find_book(arg);

	/* XbhI */
	_endthreadex(0);

	return 0;
}

/*---------------------------------------------------------------------------*
	ExcelubNXbh֐
 *---------------------------------------------------------------------------*/
unsigned __stdcall xgrep_find_book(

void		*arg)		/* |C^ */
{
	int		i, fh, rc, length, file_type, find_flag;
	struct		_finddata_t fdata;
	char		path[PATH_LEN+1], tmp_workbook[PATH_LEN+1];
	char		temp[WORD_LEN+1];
	XGREP_OPTION	*option = (XGREP_OPTION *)arg;

	sprintf(path, "%s\\*.*", option->work_directory);

	if ((fh = _findfirst(path, &fdata)) == -1) return(RTN_NORMAL);

#ifndef COMMAND_LINE
	SetWindowText(GhText[4], option->work_directory);
#endif
	do {
		sprintf(path, "%s\\%s", option->work_directory, fdata.name);

		/* I */
		if (Is_kill)  return(RTN_NORMAL);

		/* Bt@C */
		if (fdata.attrib &_A_HIDDEN) continue;

		if (fdata.attrib & _A_SUBDIR){
			if (strcmp(fdata.name, ".") != 0 && strcmp(fdata.name, "..") != 0){
				strcpy(temp, option->work_directory);
				strcpy(option->work_directory, path);

				xgrep_find_book(option);

				if (option->find_ct > XGREP_MAX_FIND){
					_findclose(fh);

					return(RTN_BUFFEROVER_ERROR);
				}
				strcpy(option->work_directory, temp);
			}
		} else {
			/* gq */
			length = strlen(fdata.name);
			str_upper(DEFAULT_OS_CHARSET, fdata.name);
			if (length >= 4 && !strstr(fdata.name, ".XLS")) continue;

#if 0
			/* t@Cʔ */
			rc = ark_file_type(IS_FALSE, path, &file_type);
#else
			/* x̂ߊgqɂt@Cʂ̂ݔɕύX */
			if (!strcmp(&fdata.name[length-5], ".XLSX")){
				file_type = FTYPE_EXCEL2007;
			} else if (!strcmp(&fdata.name[length-5], ".XLSM")){
				file_type = FTYPE_EXCEL2007_MACRO;
			} else if (!strcmp(&fdata.name[length-4], ".XLS")){
				file_type = FTYPE_EXCEL2003;
			} else {
				continue;
			}
			rc = RTN_NORMAL;
#endif
			switch (rc){
			case	RTN_NORMAL:
				switch (file_type){
				case	FTYPE_EXCEL2003:
					/* 2003`̏ꍇOLE`WorkbookZNV݂̂̈ꎞt@C쐬 */
#ifdef XGREP_MULTI_THREAD
					sprintf(tmp_workbook, "[%d]%s\\%s", Thread_no, option->temp_directory, XGREP_2003WORKBOOK);
#else
					sprintf(tmp_workbook, "%s\\%s", option->temp_directory, XGREP_2003WORKBOOK);
#endif
					if (xgrep_dump_2003WorkBook(path, tmp_workbook)){
						continue;
					}
					strcpy(option->tmp_workbook, tmp_workbook);
				case	FTYPE_EXCEL2007:
				case	FTYPE_EXCEL2007_MACRO:
					find_flag = 0;
					for (i=0; i<option->filename_ct; i++){
						if (strstr(fdata.name, option->filename[i])){
							find_flag = 1;
							break;
						}
					}
					if (option->filename_ct == 0) find_flag = 1;

					if (find_flag){
#ifdef DEBUG
printf("Excel |%s|\n", path);
#endif
						strcpy(option->path, path);
#ifdef XGREP_MULTI_THREAD
						/* 󂫃Xbh҂[v */
						while (1){
							if (xgrep_check_thread_pool() == IS_FALSE){
								continue;
							}
							/* grepXbh */
							option->thread_no = Thread_no;
							Thread_no++;

							XGREP_OPTION	*local_option;
							if ((local_option = (XGREP_OPTION *)malloc(sizeof(XGREP_OPTION))) == NULL){
								return(RTN_MALLOC_ERROR);
							}
							memcpy(local_option, option, sizeof(XGREP_OPTION));

//							Sleep(1);
							xgrep_run_thread(local_option);

//							xgrep_run_thread(option);

//							free(local_option);

							break;
						}
#else
						/* greps */
						if (xgrep_grep_book(option)){
							continue;
						}
#endif
						if (option->find_ct > XGREP_MAX_FIND){
							_findclose(fh);

							return(RTN_BUFFEROVER_ERROR);
						}
					}
					break;
				default:
					break;
				}
			default:
				break;
			}
		}
	} while (_findnext(fh, &fdata) == 0);

	_findclose(fh);

#ifdef XGREP_MULTI_THREAD
	/* SXbhI҂ */
	xgrep_wait_thread();
#endif
	return(RTN_NORMAL);
}

/*---------------------------------------------------------------------------*
	main program of X-Grep
 *---------------------------------------------------------------------------*/
int	xgrep_main(

XGREP_OPTION	*option)
{
	int		rc;
	char		arguments[WORD_LEN+1], message[WORD_LEN+1];
	DWORD		dwExCode, dThreadID;
	HANDLE		hThread;
	MSG		win_msg = { };
	FILE		*fp;

	if (Option.is_output_excel == IS_TRUE){

		sprintf(option->output_path, "%s\\%s", option->temp_directory, XGREP_RESULT_BOOK);

		/* ExcelubN_~[ */
		if ((fp = fopen(option->output_path, "wb")) == NULL){

			sprintf(message, "X-GrepExcelubN(%s)I[vG[B\r\nubNJĂꍇ͕ĂB", option->output_path);
#ifdef COMMAND_LINE
			printf("ERROR:%s\n", message);
#else
			MessageBox(GhWnd, message, XGREP_PRODUCT_NAME, MB_APPLMODAL|MB_TOPMOST|MB_ICONSTOP|MB_OK);
#endif
			return(RTN_ERROR);
		} else {
			fclose(fp);
		}

		/* ExcelubNI[v */
		sprintf(arguments, "BOOK=\"%s\"", option->output_path);

		rc = AXLS_open_book(&option->book, arguments);
		switch (rc){
		case	AXLS_OK:
			break;
		default:
			sprintf(message, "X-GrepExcelI[vG[ rc=%d", rc);
#ifdef COMMAND_LINE
			printf("ERROR:%s\n", message);
#else
			MessageBox(GhWnd, message, XGREP_PRODUCT_NAME, MB_APPLMODAL|MB_TOPMOST|MB_ICONSTOP|MB_OK);
#endif
			return(RTN_ERROR);
		}

		/* 񕝐ݒƃ^Cgso */
		strcpy(arguments, "A.=50 B.=10 C.=20 D.=100 A1=Ze B1=Z C1=V[g D1=pX(tH_N) A1:D1.zu= A1:D1.tHg.X^C=");

		rc = AXLS_put_values(&option->book, arguments);
		switch (rc){
		case	AXLS_OK:
			break;
		default:
			sprintf(message, "X-GrepExcel쐬G[ rc=%d", rc);
#ifdef COMMAND_LINE
			printf("ERROR:%s\n", message);
#else
			MessageBox(GhWnd, message, XGREP_PRODUCT_NAME, MB_APPLMODAL|MB_TOPMOST|MB_ICONSTOP|MB_OK);
#endif
			return(RTN_ERROR);
		}
	} else {
		sprintf(option->output_path, "%s\\X-Grep.txt", option->temp_directory);
#ifndef COMMAND_LINE
		unlink(option->output_path);
#endif
	}
	option->find_ct = 0;

	#ifdef COMMAND_LINE
	/* search */
	strcpy(option->work_directory, option->directory);
	option->filename_ct = 0;

	xgrep_find_book(option);
#else
	/* Xbh */
	hThread = (HANDLE)_beginthreadex(NULL, 0, xgrep_find_book_main, (void *)option, 0, (unsigned *)&dThreadID);

	/* EBhECxg`FbN */
	while (1){
		if (PeekMessage(&win_msg, GhWnd, 0, 0, PM_REMOVE)){
			xgrep_check_event(&win_msg);
			TranslateMessage(&win_msg);
			DispatchMessage(&win_msg);
		}

		GetExitCodeThread(hThread, &dwExCode);
		if (dwExCode == STILL_ACTIVE){
			continue;
		} else {
			break;
		}
	}
#endif
#ifdef XGREP_MULTI_THREAD
	/* SXbhI҂ */
	xgrep_wait_thread();
#endif

#ifndef COMMAND_LINE
	/* XbhI҂ */
	WaitForSingleObject(hThread, INFINITE);
	CloseHandle(hThread);

	if (Is_kill && option->find_ct > 0){
		rc = MessageBox(NULL, "r܂ł̌ʂ\܂H", XGREP_PRODUCT_NAME, MB_APPLMODAL|MB_ICONQUESTION|MB_YESNO);
		if (rc != IDYES){
			option->find_ct = 0;
			Is_kill = 0;

			return(RTN_NORMAL);
		}
	}
#endif
	Is_kill = 0;
	if (Option.is_output_excel == IS_TRUE){

		/* ExcelubNI[vۑ */
		rc = AXLS_close_book(&option->book, "SAVE");
		switch (rc){
		case	AXLS_OK:
			break;
		default:
			sprintf(message, "X-GrepExcelubN쐬G[ rc=%d\r\nubNJĂꍇ͕ĂB", rc);
#ifdef COMMAND_LINE
			printf("ERROR:%s\n", message);
#else
			MessageBox(GhWnd, message, XGREP_PRODUCT_NAME, MB_APPLMODAL|MB_TOPMOST|MB_ICONSTOP|MB_OK);
#endif
			return(RTN_ERROR);
		}
		if (option->find_ct){
			/* ExcelN */
			xgrep_launch_excel(option->output_path);
		} else {
#ifndef COMMAND_LINE
			sprintf(message, "Ώۂ܂łB");
			MessageBox(GhWnd, message, XGREP_PRODUCT_NAME,  MB_ICONINFORMATION|MB_OK);
#endif
			return(RTN_NORMAL);
		}
#ifndef COMMAND_LINE
	} else {
		if (option->find_ct){
			/* N */
			xgrep_launch_notepad(option->output_path);
		} else {
#ifndef COMMAND_LINE
			sprintf(message, "Ώۂ܂łB");
			MessageBox(GhWnd, message, XGREP_PRODUCT_NAME,  MB_ICONINFORMATION|MB_OK);
#endif
			return(RTN_NORMAL);
		}
#endif
	}
	option->find_ct = 0;

	return(RTN_NORMAL);
}

#ifndef COMMAND_LINE
/*---------------------------------------------------------------------------*
	GUI main program of X-Grep
 *---------------------------------------------------------------------------*/
int WINAPI	WinMain(

HINSTANCE	hCurInst,
HINSTANCE	hPrevInst,
LPSTR		lpsCmdLine,
int		nCmdShow)
{
	HWND		hWnd, hOwner;
	HANDLE		hMutex;
	MSG		win_msg = { };

	/* check duplicate run */
	hMutex = CreateMutex(NULL, FALSE, TEXT(XGREP_MUTEX_NAME));
	if (GetLastError() == ERROR_ALREADY_EXISTS){
		/* redraw exits window */
		hWnd   = FindWindow(NULL, XGREP_WINDOW_TITLE);
		hOwner = GetWindow(hWnd, GW_OWNER);
		if (IsIconic(hOwner)){
			PostMessage(hWnd, WM_SYSCOMMAND, SC_RESTORE, 0);
		} else {
			SetWindowPos(hWnd, HWND_TOPMOST, 0, 0, 0, 0, (SWP_SHOWWINDOW|SWP_NOMOVE|SWP_NOSIZE));
		}
		CloseHandle(hMutex);

		return 0;
	}

	GhInst    = hCurInst;
	GnCmdShow = nCmdShow;

	/* initialize */
	xgrep_init_option(&Option);

	/* read X-Grep.ini */
	xgrep_read_ini((char *)XGREP_INI_FILE);

	/* save initial option */
	memcpy(&Init_option, &Option, sizeof(XGREP_OPTION));

	/* create window */
	if (xgrep_create_window()){
		xgrep_main_end();
	}

	/* windows operation */
	while (GetMessage(&win_msg, NULL, 0, 0)){
		if (!TranslateAccelerator(GhWnd, GhAccel, &win_msg)){
			TranslateMessage(&win_msg);
			DispatchMessage(&win_msg);
		}
	}
	xgrep_main_end();

	return (int)win_msg.wParam;
}

/*---------------------------------------------------------------------------*
	create window
 *---------------------------------------------------------------------------*/
int	xgrep_create_window()
{
	WNDCLASSEX	wc;

	/* create font of window */
	GhFont = CreateFont(XGREP_FONT_HEIGHT, 0, 0, 0,	/* height, width, escapement, orientation(base line) */
		FW_NORMAL, FALSE, FALSE, 0,		/* font-weight, italic, under bar, strikethrough */
		SHIFTJIS_CHARSET,			/* character set */
		OUT_DEFAULT_PRECIS,			/* output precision */
		CLIP_DEFAULT_PRECIS,			/* clipping precision */
		DEFAULT_QUALITY, DEFAULT_PITCH, NULL);	/* output quality, pitch and family, font name */

	GhFont2 = CreateFont(XGREP_FONT_HEIGHT2, 0, 0, 0,	/* height, width, escapement, orientation(base line) */
		FW_NORMAL, FALSE, FALSE, 0,		/* font-weight, italic, under bar, strikethrough */
		SHIFTJIS_CHARSET,			/* character set */
		OUT_DEFAULT_PRECIS,			/* output precision */
		CLIP_DEFAULT_PRECIS,			/* clipping precision */
		DEFAULT_QUALITY, DEFAULT_PITCH, NULL);	/* output quality, pitch and family, font name */

	/* set window parameter */
	wc.cbSize        = sizeof(WNDCLASSEX);
	wc.style         = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc   = WndProc;
	wc.cbClsExtra    = 0;
	wc.cbWndExtra    = 0;
	wc.hInstance     = GhInst;
	wc.hIcon         = LoadIcon(GhInst, MAKEINTRESOURCE(XGREP_IDI_ICON1));
	wc.hIconSm       = LoadIcon(GhInst, MAKEINTRESOURCE(XGREP_IDI_ICON1));
	wc.hCursor       = (HCURSOR)LoadImage(NULL, MAKEINTRESOURCE(IDC_ARROW), IMAGE_CURSOR, 0, 0, LR_DEFAULTSIZE | LR_SHARED);
	wc.hbrBackground = (HBRUSH)(COLOR_BTNFACE + 1);
	wc.lpszMenuName  = "XGREP_DIALOG_01";
	wc.lpszClassName = (LPCSTR)szMainClass;

	/* registor window class */
	if (!RegisterClassEx(&wc)){
#ifdef DEBUG
	DEBUGwinmesg();
#endif
		xgrep_main_end();
	}

	/* generate window */
	if (!InitInstance(GhInst, GnCmdShow)){
#ifdef DEBUG
	DEBUGwinmesg();
#endif
		xgrep_main_end();
	}

	/* set accelerators */
	if ((GhAccel = LoadAccelerators(GhInst, "XGREP_ACCEL")) == NULL){
#ifdef DEBUG
	DEBUGwinmesg();
#endif
		xgrep_main_end();
	}

	return(RTN_NORMAL);

}

/*---------------------------------------------------------------------------*
	call back function of window
 *---------------------------------------------------------------------------*/
LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	int			rc;
	char			message[WORD_LEN+1];
	HDC			hDC = NULL;
	HBRUSH			hbkgnd = NULL;
	BROWSEINFO		bInfo;
	ITEMIDLIST		*pIDlist;
	PAINTSTRUCT		ps;
static	RECT			rect;
static	TCHAR			folder_name[MAX_PATH];
static	OPENFILENAME		ofn;
static	TCHAR			filename[MAX_PATH];
static	TCHAR			filename_full[MAX_PATH];

	switch (msg){
	case	WM_CREATE:
		/* edit control */
		GhText[0] = CreateWindowEx(WS_EX_CLIENTEDGE, "EDIT", "", WS_CHILD | WS_VISIBLE | WS_TABSTOP,
			TEXT_BOX1_X, TEXT_BOX1_Y, TEXT_BOX1_W, TEXT_BOX1_H, hWnd, NULL, (HINSTANCE)GetWindowLongPtr(hWnd, GWLP_HINSTANCE), NULL);
		SendMessage(GhText[0], WM_SETFONT, (WPARAM)GhFont, MAKELPARAM(FALSE, 0));
		ShowWindow(GhText[0], SW_SHOW);
		SetWindowText(GhText[0], Option.directory);

		GhText[1] = CreateWindowEx(WS_EX_CLIENTEDGE, "EDIT", "", WS_CHILD | WS_VISIBLE | WS_TABSTOP,
			TEXT_BOX2_X, TEXT_BOX2_Y, TEXT_BOX2_W, TEXT_BOX2_H, hWnd, NULL, (HINSTANCE)GetWindowLongPtr(hWnd, GWLP_HINSTANCE), NULL);
		SendMessage(GhText[1], WM_SETFONT, (WPARAM)GhFont, MAKELPARAM(FALSE, 0));
		ShowWindow(GhText[1], SW_SHOW);
		SetWindowText(GhText[1], Option.filenames);

		GhText[2] = CreateWindowEx(WS_EX_CLIENTEDGE, "EDIT", "", WS_CHILD | WS_VISIBLE | WS_TABSTOP,
			TEXT_BOX3_X, TEXT_BOX3_Y, TEXT_BOX3_W, TEXT_BOX3_H, hWnd, NULL, (HINSTANCE)GetWindowLongPtr(hWnd, GWLP_HINSTANCE), NULL);
		SendMessage(GhText[2], WM_SETFONT, (WPARAM)GhFont, MAKELPARAM(FALSE, 0));
		ShowWindow(GhText[2], SW_SHOW);
		SetWindowText(GhText[2], Option.keyword);

		GhText[3] = CreateWindowEx(WS_EX_CLIENTEDGE, "EDIT", "", WS_CHILD | WS_VISIBLE | WS_TABSTOP,
			TEXT_BOX4_X, TEXT_BOX4_Y, TEXT_BOX4_W, TEXT_BOX4_H, hWnd, NULL, (HINSTANCE)GetWindowLongPtr(hWnd, GWLP_HINSTANCE), NULL);
		SendMessage(GhText[3], WM_SETFONT, (WPARAM)GhFont, MAKELPARAM(FALSE, 0));
		ShowWindow(GhText[3], SW_SHOW);
		SetWindowText(GhText[3], Option.list_path);

		GhText[4] = CreateWindowEx(WS_EX_CLIENTEDGE, "EDIT", "", WS_CHILD | WS_VISIBLE | WS_TABSTOP,
//			TEXT_BOX5_X, TEXT_BOX5_Y, TEXT_BOX5_W, TEXT_BOX5_H, hWnd, (HMENU)XGREP_IDC_SDK_EDIT5, (HINSTANCE)GetWindowLongPtr(hWnd, GWLP_HINSTANCE), NULL);
			TEXT_BOX5_X, TEXT_BOX5_Y, TEXT_BOX5_W, TEXT_BOX5_H, hWnd, NULL, (HINSTANCE)GetWindowLongPtr(hWnd, GWLP_HINSTANCE), NULL);
		SendMessage(GhText[4], WM_SETFONT, (WPARAM)GhFont2, MAKELPARAM(FALSE, 0));
		ShowWindow(GhText[4], SW_SHOW);
		SetWindowText(GhText[4], "");
		SendMessage(GetDlgItem(hWnd, XGREP_IDC_SDK_EDIT5), EM_SETREADONLY, TRUE, 0);

		GhText[5] = CreateWindowEx(WS_EX_CLIENTEDGE, "EDIT", "", WS_CHILD | WS_VISIBLE | WS_TABSTOP,
//			TEXT_BOX6_X, TEXT_BOX6_Y, TEXT_BOX6_W, TEXT_BOX6_H, hWnd, (HMENU)XGREP_IDC_SDK_EDIT6, (HINSTANCE)GetWindowLongPtr(hWnd, GWLP_HINSTANCE), NULL);
			TEXT_BOX6_X, TEXT_BOX6_Y, TEXT_BOX6_W, TEXT_BOX6_H, hWnd, NULL, (HINSTANCE)GetWindowLongPtr(hWnd, GWLP_HINSTANCE), NULL);
		SendMessage(GhText[5], WM_SETFONT, (WPARAM)GhFont2, MAKELPARAM(FALSE, 0));
		ShowWindow(GhText[5], SW_SHOW);
		SetWindowText(GhText[5], "");
		SendMessage(GetDlgItem(hWnd, XGREP_IDC_SDK_EDIT6), EM_SETREADONLY, TRUE, 0);

		/* command button */
		CreateWindow("BUTTON", "", WS_CHILD | WS_VISIBLE | BS_FLAT | WS_TABSTOP,
				FIND_BTN_X, FIND_BTN_Y, FIND_BTN_W, FIND_BTN_H, hWnd, (HMENU)XGREP_IDC_SDK_FIND, GhInst, NULL);
		GhBtn[0] = GetDlgItem(hWnd, XGREP_IDC_SDK_FIND);
		SendMessage(GhBtn[0], WM_SETFONT, (WPARAM)GhFont, MAKELPARAM(FALSE, 0));

		CreateWindow("BUTTON", "LZ", WS_CHILD | WS_VISIBLE | BS_FLAT | WS_TABSTOP,
				CANCEL_BTN_X, CANCEL_BTN_Y, CANCEL_BTN_W, CANCEL_BTN_H, hWnd, (HMENU)XGREP_IDC_SDK_CANCEL, GhInst, NULL);
		GhBtn[1] = GetDlgItem(hWnd, XGREP_IDC_SDK_CANCEL);
		SendMessage(GhBtn[1], WM_SETFONT, (WPARAM)GhFont, MAKELPARAM(FALSE, 0));

		CreateWindow("BUTTON", "...", WS_CHILD | WS_VISIBLE | BS_FLAT | WS_TABSTOP,
				FOLDER_BTN_X, FOLDER_BTN_Y, FOLDER_BTN_W, FOLDER_BTN_H, hWnd, (HMENU)XGREP_IDC_SDK_FOLDER, GhInst, NULL);
		GhBtn[2] = GetDlgItem(hWnd, XGREP_IDC_SDK_FOLDER);
		SendMessage(GhBtn[2], WM_SETFONT, (WPARAM)GhFont, MAKELPARAM(FALSE, 0));

		CreateWindow("BUTTON", "...", WS_CHILD | WS_VISIBLE | BS_FLAT | WS_TABSTOP,
				FILE_BTN_X, FILE_BTN_Y, FILE_BTN_W, FILE_BTN_H, hWnd, (HMENU)XGREP_IDC_SDK_FILE, GhInst, NULL);
		GhBtn[3] = GetDlgItem(hWnd, XGREP_IDC_SDK_FILE);
		SendMessage(GhBtn[3], WM_SETFONT, (WPARAM)GhFont, MAKELPARAM(FALSE, 0));

		/* check box */
		GhChk[0] = CreateWindowEx(0, "BUTTON", "Excelo", WS_CHILD | BS_AUTOCHECKBOX,
			CHECK_BOX1_X, CHECK_BOX1_Y, CHECK_BOX1_W, CHECK_BOX1_H, hWnd, (HMENU)XGREP_IDC_SDK_CHECK1, GhInst, NULL);
		SendMessage(GhChk[0], WM_SETFONT, (WPARAM)GhFont, MAKELPARAM(FALSE, 0));
		ShowWindow(GhChk[0], SW_SHOW);

		if (Option.is_output_excel == IS_TRUE){
			SendMessage(GhChk[0], BM_SETCHECK, BST_CHECKED, 0);
		} else {
			SendMessage(GhChk[0], BM_SETCHECK, BST_UNCHECKED, 0);
		}

		GhChk[1] = CreateWindowEx(0, "BUTTON", "K\", WS_CHILD | BS_AUTOCHECKBOX,
			CHECK_BOX2_X, CHECK_BOX2_Y, CHECK_BOX2_W, CHECK_BOX2_H, hWnd, (HMENU)XGREP_IDC_SDK_CHECK2, GhInst, NULL);
		SendMessage(GhChk[1], WM_SETFONT, (WPARAM)GhFont, MAKELPARAM(FALSE, 0));
		ShowWindow(GhChk[1], SW_SHOW);

		if (Option.is_regular_expression == IS_TRUE){
			SendMessage(GhChk[1], BM_SETCHECK, BST_CHECKED, 0);
		} else {
			SendMessage(GhChk[1], BM_SETCHECK, BST_UNCHECKED, 0);
		}

		break;
	case	WM_PAINT:
		hDC = BeginPaint(hWnd, &ps);
		SetBkMode(hDC, TRANSPARENT);
		SelectObject(hDC, GhFont);

		/* bitmap */
		load_BMP(hWnd, hDC);

		/* drow message */
		TextOut(hDC, TEXT_BOX1_X,  TEXT_BOX1_Y-15, "ΏۃtH_", strlen("ΏۃtH_"));
		TextOut(hDC, TEXT_BOX2_X,  TEXT_BOX2_Y-15, "t@CL[[h",   strlen("t@CL[[h"));
		TextOut(hDC, TEXT_BOX3_X,  TEXT_BOX3_Y-15, "e",     strlen("e"));
		TextOut(hDC, TEXT_BOX4_X,  TEXT_BOX4_Y-15, "eXgt@C", strlen("eXgt@C"));

		EndPaint(hWnd, &ps);
		break;
	case	WM_CTLCOLOREDIT:
		if (GetWindowLong((HWND)lParam, GWL_ID) == XGREP_IDC_SDK_EDIT5){
			HDC hdcStatic = (HDC)wParam;
			SetTextColor(hdcStatic, RGB(255,255,255));
			SetBkColor(hdcStatic, RGB(0,0,0));

			return (INT_PTR)CreateSolidBrush(RGB(128,128,128));
		
		}
		break;
	case	WM_COMMAND:

		/* button click */
		switch (LOWORD(wParam)){
		case	XGREP_IDC_SDK_FOLDER:
			/* folder dialog */
			bInfo.hwndOwner      = hWnd;
			bInfo.pidlRoot       = NULL;
			bInfo.pszDisplayName = folder_name;
			bInfo.lpszTitle      = _T("ΏۃtH_");
			bInfo.ulFlags        = BIF_RETURNONLYFSDIRS;
			bInfo.lpfn           = BrowseCallbackProc;
			bInfo.lParam         = (LPARAM)Option.directory;

			if (!(pIDlist = SHBrowseForFolder(&bInfo))){
				break;
			}
			SHGetPathFromIDList(pIDlist, folder_name);
			strcpy(Option.directory, folder_name);
			strcat(Option.directory, "\\");
			SetWindowText(GhText[0], Option.directory);

			break;
		case	XGREP_IDC_SDK_FILE:
			ZeroMemory(&ofn, sizeof(ofn));
			ofn.lStructSize = sizeof(ofn);
			ofn.hwndOwner = hWnd;
			ofn.lpstrFilter = _T("All files(*.*)\0*.*\0\0");
			ofn.lpstrFile = filename_full;
			ofn.lpstrFileTitle = filename;
			ofn.nMaxFile = sizeof(filename_full);
			ofn.nMaxFileTitle = sizeof(filename);
			ofn.Flags = OFN_FILEMUSTEXIST;
			ofn.lpstrTitle = _T("ΏۃXgt@C");
			ofn.lpstrDefExt = _T("");

			if (!GetOpenFileName(&ofn)){
				break;
			}
			strcpy(Option.list_path, filename_full);
			SetWindowText(GhText[3], Option.list_path);

			break;
		case	XGREP_IDC_SDK_FIND:

			/* output file name */
			GetWindowText(GhText[0], Option.directory, sizeof(Option.directory));
			GetWindowText(GhText[1], Option.filenames, sizeof(Option.filenames));
			swap_mbspace(DEFAULT_OS_CHARSET, (unsigned char *)Option.filenames);
			GetWindowText(GhText[2], Option.keyword,   sizeof(Option.keyword));
			swap_mbspace(DEFAULT_OS_CHARSET, (unsigned char *)Option.keyword);
			GetWindowText(GhText[3], Option.list_path, sizeof(Option.list_path));
			if (Option.keyword[0] == 0x00 && Option.list_path[0] == 0x00){
				MessageBox(GhWnd, "ew肳Ă܂B", XGREP_PRODUCT_NAME, MB_APPLMODAL|MB_TOPMOST|MB_ICONSTOP|MB_OK);
				break;
			}
			if (IsDlgButtonChecked(hWnd, XGREP_IDC_SDK_CHECK1) == BST_CHECKED){
				Option.is_output_excel = IS_TRUE;
			} else {
				Option.is_output_excel = IS_FALSE;
			}
			if (IsDlgButtonChecked(hWnd, XGREP_IDC_SDK_CHECK2) == BST_CHECKED){
				Option.is_regular_expression = IS_TRUE;
			} else {
				Option.is_regular_expression = IS_FALSE;
			}
			if (xgrep_parse_option(&Option)){
				break;
			}

			EnableWindow(GhText[0], FALSE);
			EnableWindow(GhText[1], FALSE);
			EnableWindow(GhText[2], FALSE);
			EnableWindow(GhText[3], FALSE);
//			EnableWindow(GhText[4], FALSE);
//			EnableWindow(GhText[5], FALSE);
			EnableWindow(GhChk[0], FALSE);
			EnableWindow(GhChk[1], FALSE);
			EnableWindow(GhBtn[0], FALSE);
			EnableWindow(GhBtn[2], FALSE);
			EnableWindow(GhBtn[3], FALSE);

			/* search option->book */
			xgrep_main(&Option);

			EnableWindow(GhText[0], TRUE);
			EnableWindow(GhText[1], TRUE);
			EnableWindow(GhText[2], TRUE);
			EnableWindow(GhText[3], TRUE);
//			EnableWindow(GhText[4], TRUE);
//			EnableWindow(GhText[5], TRUE);
			EnableWindow(GhChk[0], TRUE);
			EnableWindow(GhChk[1], TRUE);
			EnableWindow(GhBtn[0], TRUE);
			EnableWindow(GhBtn[2], TRUE);
			EnableWindow(GhBtn[3], TRUE);

			SetWindowText(GhText[4], "");
			SetWindowText(GhText[5], "");

			break;
		case	XGREP_IDC_SDK_CANCEL:

			if (Option.find_ct > 0){

				sprintf(message, "%dĂ܂B\r𒆎~܂H", Option.find_ct);

				rc = MessageBox(hWnd, message, XGREP_PRODUCT_NAME, MB_APPLMODAL|MB_ICONQUESTION|MB_YESNO);
				if (rc == IDYES){
					/* XbhItOON */
					Is_kill = 1;
				}
				return 0;
			}
			if (xgrep_is_update_option() == IS_TRUE){
				rc = MessageBox(hWnd, "ݒۑ܂H", XGREP_PRODUCT_NAME, MB_APPLMODAL|MB_ICONQUESTION|MB_YESNO);
				if (rc == IDYES){
					xgrep_write_ini(XGREP_INI_FILE);
				}
			}
			xgrep_main_end();

			break;
		case	XGREP_IDM_END:
			if (xgrep_is_update_option() == IS_TRUE){
				rc = MessageBox(hWnd, "ݒۑ܂H", XGREP_PRODUCT_NAME, MB_APPLMODAL|MB_ICONQUESTION|MB_YESNO);
				if (rc == IDYES){
					xgrep_write_ini(XGREP_INI_FILE);
				}
			}
			/* close window */
			DestroyWindow(hWnd);

			xgrep_main_end();

			break;
		case	XGREP_IDM_SAVE:

			GetWindowText(GhText[0], Option.directory, sizeof(Option.directory));
			GetWindowText(GhText[1], Option.filenames, sizeof(Option.filenames));
			swap_mbspace(DEFAULT_OS_CHARSET, (unsigned char *)Option.filenames);
			GetWindowText(GhText[2], Option.keyword,   sizeof(Option.keyword));
			swap_mbspace(DEFAULT_OS_CHARSET, (unsigned char *)Option.keyword);
			GetWindowText(GhText[3], Option.list_path, sizeof(Option.list_path));
			if (IsDlgButtonChecked(hWnd, XGREP_IDC_SDK_CHECK1) == BST_CHECKED){
				Option.is_output_excel = IS_TRUE;
			} else {
				Option.is_output_excel = IS_FALSE;
			}
			if (IsDlgButtonChecked(hWnd, XGREP_IDC_SDK_CHECK2) == BST_CHECKED){
				Option.is_regular_expression = IS_TRUE;
			} else {
				Option.is_regular_expression = IS_FALSE;
			}
			xgrep_write_ini(XGREP_INI_FILE);

			/* save option */
			memcpy(&Init_option, &Option, sizeof(XGREP_OPTION));

			break;
		case	XGREP_IDM_HELP:

			/* HELP dialog */
			sprintf(message, "ut@CL[[hvɂ̓t@CɊ܂܂镶Ap/SpXy[X؂ŕw肷邱Ƃł܂B\n\r"\
				"uevɂ͌ΏەAp/SpXy[X؂ŕw肷邱Ƃł܂B\n\r"\
				"ueXgt@Cvɂ͌ΏەApXy[X/^u/s؂ŗ񂵂eLXgt@C(SJIS)w肵܂B\n\r\n"
				"ftHg͕vłBuK\v͕vł͂ȂA܂ChJ[hƂقȂ܂̂ŁAwɂ͒ӂKvłB\n\r\n"
				"t\"2016/3/25\"̗lȁAXbV؂0ߖ`Ōł܂B\n\r\n"
				"JĂubNƁAǂݎpX[hݒ肳ĂubŃAΏۊOłB\n\r"
				"Excelo͂̏ꍇ́Aʂ1ɓBƏI܂B\n\r"
				"Excel2003ȑOł́Aʂ𐳂\邱Ƃ͂ł܂B\n\r\n");
			MessageBox(GhWnd, message, XGREP_PRODUCT_NAME, MB_APPLMODAL|MB_OK);

			break;
		case	XGREP_IDM_VERSION:
			sprintf(message, "%s    \r\nVersion : %s\r\n   yARK X-TRAiN sample toolz\r\nA[Ng(arktran.com)\r\n", XGREP_PRODUCT_NAME, XGREP_VERSION);
			MessageBox(hWnd, message, XGREP_PRODUCT_NAME, MB_APPLMODAL|MB_TOPMOST|MB_OK);

			break;
		}

		break;
	case	WM_CLOSE:
		if (xgrep_is_update_option() == IS_TRUE){
			rc = MessageBox(hWnd, "ݒۑ܂H", XGREP_PRODUCT_NAME, MB_APPLMODAL|MB_ICONQUESTION|MB_YESNO);
			if (rc == IDYES){
				xgrep_write_ini(XGREP_INI_FILE);
			}
		}
		/* close window */
		xgrep_main_end();

		break;
	case	WM_DESTROY:
		/* destruction window  */
		PostQuitMessage(0);

		break;
	default:
		/* default process */
		return (DefWindowProc(hWnd, msg, wParam, lParam));
	}

	return 0;
}

/*---------------------------------------------------------------------------*
	initial instance
 *---------------------------------------------------------------------------*/
BOOL	InitInstance(HINSTANCE GhInst, int nCmdShow)
{
	int		x, y;
	HWND		hWnd;
	RECT		rt = {0, 0, XGREP_WINDOW_WIDTH, XGREP_WINDOW_HEIGHT};

	AdjustWindowRectEx(&rt, WS_OVERLAPPEDWINDOW, FALSE, WS_EX_OVERLAPPEDWINDOW);

	x = (GetSystemMetrics(SM_CXSCREEN) - XGREP_WINDOW_WIDTH)  / 2;
	y = (GetSystemMetrics(SM_CYSCREEN) - XGREP_WINDOW_HEIGHT) / 2;

	hWnd = CreateWindowEx(
		WS_EX_OVERLAPPEDWINDOW,	/* extended window style  */
		szMainClass,		/* class name */
		szWindowsTitle,		/* window title */
		WS_OVERLAPPEDWINDOW & ~WS_MAXIMIZEBOX & ~WS_SIZEBOX,
					/* extended window style  */
					/* window kind */
		x,			/* position X */
		y,			/* position Y */
		rt.right -rt.left,	/* width */
		rt.bottom-rt.top,	/* height */
		NULL,			/* handle of parent window */
		NULL,			/* handle of menu */
		GhInst,			/* handle of aplication instanse */
		NULL);

	if (!hWnd){
		return FALSE;
	}

	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);

	GhWnd = hWnd;

	return TRUE;
}

/*---------------------------------------------------------------------------*
	Cxg
 *---------------------------------------------------------------------------*/
int	xgrep_check_event(

MSG		*win_msg)
{
	switch (win_msg->message){
	case	WM_COMMAND:
		switch (LOWORD(win_msg->wParam)){
		case	XGREP_IDM_END:
			exit(0);
		default:
			break;
		}
		break;
	case	WM_PAINT:

		UpdateWindow(GhWnd);

		break;
	case	WM_QUIT:
	case	WM_CLOSE:
		/* I */
		DestroyWindow(GhWnd);
		DeleteObject(GhFont);
		exit(0);
	default:
		return DefWindowProc(GhWnd, win_msg->message, win_msg->wParam, win_msg->lParam);
	}
	return(RTN_NORMAL);
}

/*---------------------------------------------------------------------------*
	Folder dialog callback routine
 *---------------------------------------------------------------------------*/
int	CALLBACK BrowseCallbackProc(HWND hWnd, UINT uMsg, LPARAM lParam, LPARAM lpData)
{
	if (uMsg == BFFM_INITIALIZED){
		SendMessage(hWnd, BFFM_SETSELECTION, (WPARAM)TRUE, lpData);
	}
	return 0;
}

/*---------------------------------------------------------------------------*
	load bitmap from resource file
 *---------------------------------------------------------------------------*/
int	load_BMP(HWND hWnd, HDC hdc)
{
	HDC		hmdc;
	HBITMAP		hBitmap;
	BITMAP		bmp;
	HINSTANCE	hInst;
	int		BMP_W, BMP_H;

	hInst = (HINSTANCE)GetWindowLongPtr(hWnd, GWLP_HINSTANCE);
	hBitmap = (HBITMAP)LoadImage(GhInst, MAKEINTRESOURCE(XGREP_IDI_BMP1), IMAGE_BITMAP, 0, 0, LR_CREATEDIBSECTION);
	if (hBitmap == NULL){
		return 0;
	}
	GetObject(hBitmap, sizeof(BITMAP), &bmp);
	BMP_W = (int)bmp.bmWidth;
	BMP_H = (int)bmp.bmHeight;
	hmdc = CreateCompatibleDC(hdc);

	SelectObject(hmdc, hBitmap);
	BitBlt(hdc, BITMAP_X, BITMAP_Y, BMP_W, BMP_H, hmdc, 0, 0, SRCCOPY);
	DeleteDC(hmdc);
	DeleteObject(hBitmap);

	return 0;
}

/*---------------------------------------------------------------------------*
	end process of X-Grep
 *---------------------------------------------------------------------------*/
int	xgrep_main_end()
{
	/* delete font */
	DeleteObject(GhFont);

	exit(0);
}

#else

/*---------------------------------------------------------------------------*
	CommandLine main program
 *---------------------------------------------------------------------------*/
int	main(

int		argc,
char		*argv[])
{
	xgrep_init_option(&Option);

	/* read X-Grep.ini */
	xgrep_read_ini((char *)XGREP_INI_FILE);

	if (argc < 2){
		printf("[hɎw肵Ă\n");
		exit(-1);
	}
	strcpy(Option.keyword, argv[1]);
	if (argc > 2){
		strcpy(Option.directory, argv[2]);
	}
	xgrep_parse_option(&Option);

	if (xgrep_main(&Option)){
		exit(-1);
	}
	exit(0);
}

#endif

/*---------------------------------------------------------------------------*
	initialize option
 *---------------------------------------------------------------------------*/
int	xgrep_init_option(

XGREP_OPTION	*option)
{
	char		*env;

	option->thread_no = 0;

	option->is_output_excel       = IS_FALSE;
	option->is_regular_expression = IS_FALSE;

	option->keyword[0]   = 0x00;
	option->filenames[0] = 0x00;
	option->filename_ct  = 0;
	option->pattern_ct   = 0;
	option->find_ct      = 0;

	strcpy(option->directory,      "");
	strcpy(option->temp_directory, "C:\\Temp");
	if ((env = getenv("TEMP")) != NULL){
		strcpy(option->temp_directory, env);
	}

	GetCurrentDirectory(sizeof(option->current_directory), option->current_directory);

	return(RTN_NORMAL);
}

/*---------------------------------------------------------------------------*
	compare optios
 *---------------------------------------------------------------------------*/
int	xgrep_is_update_option()
{
	if (strcmp(Init_option.directory, Option.directory)){
		return(IS_TRUE);
	}
	if (strcmp(Init_option.keyword, Option.keyword)){
		return(IS_TRUE);
	}
	if (strcmp(Init_option.filenames, Option.filenames)){
		return(IS_TRUE);
	}
	if (strcmp(Init_option.list_path, Option.list_path)){
		return(IS_TRUE);
	}
	if (Init_option.is_output_excel != Option.is_output_excel){
		return(IS_TRUE);
	}
	if (Init_option.is_regular_expression != Option.is_regular_expression){
		return(IS_TRUE);
	}
	return(IS_FALSE);
}

/*---------------------------------------------------------------------------*
	read X-Grep ini file
 *---------------------------------------------------------------------------*/
int	xgrep_read_ini(

char		*ini_fname)
{
	int		rc;
	char		ini_path[PATH_LEN+1], value[WORD_LEN+1];
#if (defined(WINDOWS) || defined(CYGWIN)) && !defined(COMMAND_LINE)
	int		i;
	char		exe_path[PATH_LEN+1];
#endif
	INI_FILE	inifile;

	/* initialize */
	memset(&inifile, 0x00, sizeof(inifile));
	memset(ini_path, 0x00, sizeof(ini_path));

#if (defined(WINDOWS) || defined(CYGWIN)) && !defined(COMMAND_LINE)

	/* get current directory */
	GetModuleFileName(NULL, exe_path, PATH_LEN);

	for (i=strlen(exe_path)-1; i>=0; i--){
		if (exe_path[i] == '\\'){
			memcpy(ini_path, exe_path, i);
			break;
		}
	}
	strcat(ini_path, "\\");
	strcat(ini_path, ini_fname);
#else
	strcpy(ini_path, ini_fname);
#endif
	/* read ini file */
	strcpy(inifile.path, ini_path);
	inifile.charset = CHARSET_SJIS;
	strcpy(inifile.password, XGREP_INI_PASSWORD);

	if ((rc = ark_read_inifile(&inifile))){
		switch	(rc){
		case	RTN_NORMAL:
			break;
		case	RTN_MALLOC_ERROR:
		case	RTN_FOPEN_ERROR:
			return(rc);
		default:
			return(rc);
		}
	}

	/* set option parameter */
	if (!ark_get_inifile_value(&inifile, INI_OPTION_NONE, (char *)"DIRECTORY", value)){
		if (strlen(value) <= PATH_LEN){
			strcpy(Option.directory, value);
		}
	}
	if (!ark_get_inifile_value(&inifile, INI_OPTION_NONE, (char *)"FILENAMES", value)){
		if (strlen(value) <= PATH_LEN){
			strcpy(Option.filenames, value);
		}
	}
	if (!ark_get_inifile_value(&inifile, INI_OPTION_NONE, (char *)"LIST_PATH", value)){
		if (strlen(value) <= PATH_LEN){
			strcpy(Option.list_path, value);
		}
	}
	if (!ark_get_inifile_value(&inifile, INI_OPTION_NONE, (char *)"KEYWORD", value)){
		if (strlen(value) <= WORD_LEN){
			strcpy(Option.keyword, value);
		}
	}
	if (!ark_get_inifile_value(&inifile, INI_OPTION_NONE, (char *)"IS_OUTPUT_EXCEL", value)){
		if (!strcasecmp(value, "Y")){
			Option.is_output_excel = IS_TRUE;
		}
	}
	if (!ark_get_inifile_value(&inifile, INI_OPTION_NONE, (char *)"IS_REGULAR_EXPRESSION", value)){
		if (!strcasecmp(value, "Y")){
			Option.is_regular_expression = IS_TRUE;
		}
	}

	return(RTN_NORMAL);
}

/*---------------------------------------------------------------------------*
	write X-Grep ini file
 *---------------------------------------------------------------------------*/
int	xgrep_write_ini(

char		*ini_fname)
{
	char		ini_path[PATH_LEN+1], value[WORD_LEN+1];
#if (defined(WINDOWS) || defined(CYGWIN)) && !defined(COMMAND_LINE)
	int		i;
	char		exe_path[PATH_LEN+1];
#endif
	INI_FILE	inifile;

	/* initialize */
	memset(&inifile, 0x00, sizeof(inifile));
	memset(ini_path, 0x00, sizeof(ini_path));
	strcpy(inifile.password, XGREP_INI_PASSWORD);

#if (defined(WINDOWS) || defined(CYGWIN)) && !defined(COMMAND_LINE)

	/* get current directory */
	GetModuleFileName(NULL, exe_path, PATH_LEN);

	for (i=strlen(exe_path)-1; i>=0; i--){
		if (exe_path[i] == '\\'){
			memcpy(ini_path, exe_path, i);
			break;
		}
	}
	strcat(ini_path, "\\");
	strcat(ini_path, ini_fname);
#else
	strcpy(ini_path, ini_fname);
#endif
	/* set option parameter */
	strcpy(value, Option.directory);
	if (ark_set_inifile_value(&inifile, INI_OPTION_NONE, (char *)"DIRECTORY", value)){
		return(RTN_ERROR);
	}
	strcpy(value, Option.filenames);
	if (ark_set_inifile_value(&inifile, INI_OPTION_NONE, (char *)"FILENAMES", value)){
		return(RTN_ERROR);
	}
	strcpy(value, Option.list_path);
	if (ark_set_inifile_value(&inifile, INI_OPTION_NONE, (char *)"LIST_PATH", value)){
		return(RTN_ERROR);
	}
	strcpy(value, Option.keyword);
	if (ark_set_inifile_value(&inifile, INI_OPTION_NONE, (char *)"KEYWORD", value)){
		return(RTN_ERROR);
	}
	if (Option.is_output_excel == IS_TRUE){
		strcpy(value, "Y");
	} else {
		strcpy(value, "N");
	}
	if (ark_set_inifile_value(&inifile, INI_OPTION_NONE, (char *)"IS_OUTPUT_EXCEL", value)){
		return(RTN_ERROR);
	}
	if (Option.is_regular_expression == IS_TRUE){
		strcpy(value, "Y");
	} else {
		strcpy(value, "N");
	}
	if (ark_set_inifile_value(&inifile, INI_OPTION_NONE, (char *)"IS_REGULAR_EXPRESSION", value)){
		return(RTN_ERROR);
	}

	/* write ini file */
	strcpy(inifile.path,    ini_path);
	strcpy(inifile.section, XGREP_PRODUCT_NAME);
	inifile.charset = CHARSET_SJIS;

	if (ark_write_inifile(&inifile)){
		ark_free_inifile(&inifile);

		return(RTN_NORMAL);
	}
	ark_free_inifile(&inifile);

	return(RTN_NORMAL);
}

/*---------------------------------------------------------------------------*
	IvV
 *---------------------------------------------------------------------------*/
int	xgrep_parse_option(

XGREP_OPTION	*option)
{
	int		idx, alloc_ct;
	char		word[WORD_LEN+1], message[WORD_LEN+1], buffer[0x4000];
	FILE		*fp;

	option->pattern_ct = 0;
	alloc_ct = 0;
	if (ark_realloc_2d_buffer((void ***)&option->pattern, option->pattern_ct+1, &alloc_ct, option->pattern_ct, WORD_LEN+1, 10)){
		return(RTN_MALLOC_ERROR);
	}

	/* eXgt@C */
	if (option->list_path[0] != 0x00){
		if ((fp = fopen(option->list_path, "rt")) == NULL){
			sprintf(message, "eXgt@C(%s)I[vG[", option->list_path);
#ifdef COMMAND_LINE
			printf("ERROR:%s\n", message);
#else
			MessageBox(GhWnd, message, XGREP_PRODUCT_NAME, MB_APPLMODAL|MB_TOPMOST|MB_ICONSTOP|MB_OK);
#endif
			return(RTN_FOPEN_ERROR);
		}
		while (fgets(buffer, sizeof(buffer), fp)){
			idx = 0;
			while (!ark_next_word(DEFAULT_OS_CHARSET, buffer, &idx, word)){
				if (ark_realloc_2d_buffer((void ***)&option->pattern, option->pattern_ct+1, &alloc_ct, option->pattern_ct, WORD_LEN+1, 10)){
					return(RTN_MALLOC_ERROR);
				}
				strcpy(option->pattern[option->pattern_ct], word);
				option->pattern_ct++;
			}
		}
		fclose(fp);
	}

	/* [h */
	idx = 0;
	while (!ark_next_word(DEFAULT_OS_CHARSET, option->keyword, &idx, word)){

		if (ark_realloc_2d_buffer((void ***)&option->pattern, option->pattern_ct+1, &alloc_ct, option->pattern_ct, WORD_LEN+1, 10)){
			return(RTN_MALLOC_ERROR);
		}
		strcpy(option->pattern[option->pattern_ct], word);
		option->pattern_ct++;
	}

	/* t@C */
	idx = 0;
	option->filename_ct = 0;

	while (!ark_next_word(DEFAULT_OS_CHARSET, option->filenames, &idx, word)){

		if (option->filename_ct >= XGREP_MAX_FILENAME) break;

		strcpy(option->filename[option->filename_ct], word);
		option->filename_ct++;
	}
	return(RTN_NORMAL);
}

#ifdef XGREP_MULTI_THREAD
/*---------------------------------------------------------------------------*
	grepXbhC
 *---------------------------------------------------------------------------*/
unsigned __stdcall xgrep_grep_book_main(

void		*arg)		/* |C^ */
{
	XGREP_OPTION	*option = (XGREP_OPTION *)arg;

	/* Grep */
	xgrep_grep_book(option);

	/* XbhI */
	_endthreadex(0);

	return 0;
}

/*---------------------------------------------------------------------------*
	XbhC
 *---------------------------------------------------------------------------*/
void	xgrep_run_thread(

XGREP_OPTION	*option)
{
	DWORD		dThreadID;
	HANDLE		hThread;

	/* Xbh */
	hThread = (HANDLE)_beginthreadex(NULL, 0, xgrep_grep_book_main, (void *)option, 0, (unsigned *)&dThreadID);

	ThreadPool[Thread_ct].hThread = hThread;
	ThreadPool[Thread_ct].no      = Thread_no;
	Thread_ct++;

	return;
}

/*---------------------------------------------------------------------------*
	Xbhv[󂫃`FbN
 *---------------------------------------------------------------------------*/
int	xgrep_check_thread_pool()
{
	int		i, term_flg = 0;
	DWORD		msec = XGREP_TREAD_WAIT_MSEC;

	if (Thread_ct < Max_thread){
		term_flg = 1;
	} else {
		for (i=0; i<Thread_ct; i++){
			if (WaitForSingleObject(ThreadPool[i].hThread, msec) == WAIT_OBJECT_0){

				CloseHandle(ThreadPool[i].hThread);
				ThreadPool[i].hThread = 0x00;

				for (; i<Max_thread-1; i++){
					ThreadPool[i].no      = ThreadPool[i+1].no;
					ThreadPool[i].hThread = ThreadPool[i+1].hThread;
				}
				Thread_ct--;
				term_flg = 1;
				break;
			}
		}
	}
	if (term_flg){
		return(IS_TRUE);
	} else {
		return(IS_FALSE);
	}
}

/*---------------------------------------------------------------------------*
	SXbhI҂
 *---------------------------------------------------------------------------*/
void	xgrep_wait_thread()
{
	int		i;
	DWORD		msec = XGREP_TREAD_WAIT_MSEC;

	for (i=0; i<Thread_ct; i++){
		if (ThreadPool[i].hThread != 0x00){
			if (WaitForSingleObject(ThreadPool[i].hThread, msec) == WAIT_OBJECT_0){
				CloseHandle(ThreadPool[i].hThread);
				ThreadPool[i].hThread = 0x00;
				ThreadPool[i].no      = 0;
			}
		}
	}
	Thread_ct = 0;

	return;
}
#endif

/*---------------------------------------------------------------------------*
	write Excel2003 WorkBook temp file
 *---------------------------------------------------------------------------*/
int	xgrep_dump_2003WorkBook(

char		*xls_path,
char		*tmp_path)
{
	int		is_retry = IS_FALSE;
	unsigned char	buffer[1024];
	char		workbook[16];
#ifdef IS_ON_MEMORY
	MFILE		*mpw;
#else
	FILE		*fpw;
#endif
	POLE::Storage* storage = new POLE::Storage(xls_path);
	storage->open();

	if (storage->result() != POLE::Storage::Ok){
		return(RTN_ERROR);
	}
	strcpy(workbook, "Workbook");
RETRY:
	POLE::Stream* stream = new POLE::Stream(storage, workbook);

	if (!stream){
		return(RTN_ERROR);
	}
	if (stream->fail()){
		/* retry for Excel95 */
		if (is_retry == IS_TRUE){
			return(RTN_ERROR);
		}
		strcpy(workbook, "Book");
		is_retry = IS_TRUE;
		goto RETRY;
	}
#ifdef IS_ON_MEMORY
	if ((mpw = mopen(tmp_path, "wb")) == NULL){
		return(RTN_FOPEN_ERROR);
	}
#else
	if ((fpw = fopen(tmp_path, "wb")) == NULL){
		return(RTN_FOPEN_ERROR);
	}
#endif
	for (;;){
		unsigned read = stream->read(buffer, sizeof(buffer));
#ifdef IS_ON_MEMORY
		mwrite((const char *)buffer, read, 1, mpw);
#else
		fwrite(buffer, read, 1, fpw);
#endif
		if (read < sizeof(buffer)) break;
	}
#ifdef IS_ON_MEMORY
	mclose(mpw);
#else
	fclose(fpw);
#endif
	storage->close();

	delete stream;

	return(RTN_NORMAL);
}

/*---------------------------------------------------------------------------*
	ExcelN
 *---------------------------------------------------------------------------*/
int	xgrep_launch_excel(

char		*path)
{
	HKEY			hRootKey;
	char			KeyName[256],szBuff[256];
	char			command[32768];
	DWORD			cbBuff;
	STARTUPINFO		sinfo;
	PROCESS_INFORMATION	pinfo;

	/* open registry key by Excel */
	strcpy(KeyName, REGKEY_EXCEL);
	if (RegOpenKeyEx(HKEY_LOCAL_MACHINE, KeyName, 0, KEY_READ, &hRootKey) != ERROR_SUCCESS){
		if (RegOpenKeyEx(HKEY_LOCAL_MACHINE, KeyName, 0, KEY_READ|KEY_WOW64_64KEY, &hRootKey) != ERROR_SUCCESS){
			if (RegOpenKeyEx(HKEY_LOCAL_MACHINE, KeyName, 0, KEY_READ|KEY_WOW64_32KEY, &hRootKey) != ERROR_SUCCESS){
				return(RTN_ERROR);
			}
		}
	}
	cbBuff = sizeof(szBuff);

	/* get Excel class ID */
	if (RegQueryValueEx(hRootKey, NULL, NULL, NULL, (LPBYTE)szBuff, &cbBuff) != ERROR_SUCCESS){
		RegCloseKey(hRootKey);
		return(RTN_ERROR);
	}

	/* open registry key by class ID */
	sprintf(KeyName, REGKEY_CLASS, szBuff);
	if (RegOpenKeyEx(HKEY_LOCAL_MACHINE, KeyName, 0, KEY_READ, &hRootKey) != ERROR_SUCCESS){
		if (RegOpenKeyEx(HKEY_LOCAL_MACHINE, KeyName, 0, KEY_READ|KEY_WOW64_64KEY, &hRootKey) != ERROR_SUCCESS){
			if (RegOpenKeyEx(HKEY_LOCAL_MACHINE, KeyName, 0, KEY_READ|KEY_WOW64_32KEY, &hRootKey) != ERROR_SUCCESS){
				return(RTN_ERROR);
			}
		}
	}
	cbBuff = sizeof(szBuff);

	/* get Excel path */
	szBuff[0] = 0x00;
	if (RegQueryValueEx(hRootKey, NULL, NULL, NULL, (LPBYTE)szBuff, &cbBuff) != ERROR_SUCCESS){
		RegCloseKey(hRootKey);
		return(RTN_ERROR);
	}
	if (szBuff[0] == 0x00){
		return(RTN_ERROR);
	}

	/* open Excel */
	memset(&sinfo, 0x00, sizeof(STARTUPINFO));
	memset(&pinfo, 0x00, sizeof(PROCESS_INFORMATION));
	sinfo.cb = sizeof(STARTUPINFO);
	sinfo.dwFlags = STARTF_USESHOWWINDOW;
	sinfo.wShowWindow = SW_SHOWNORMAL;

	sprintf(command, "%s \"%s\"", szBuff, path);

	if (!CreateProcess(NULL, command, NULL, NULL, FALSE, NORMAL_PRIORITY_CLASS, NULL, NULL, &sinfo, &pinfo)){
		return(RTN_ERROR);
	}

	return(RTN_NORMAL);
}

/*---------------------------------------------------------------------------*
	NotepadN
 *---------------------------------------------------------------------------*/
int	xgrep_launch_notepad(

char		*path)
{
	char			command[32768], ctemp[1024];
	STARTUPINFO		sinfo;
	PROCESS_INFORMATION	pinfo;

	/* open Notepad */
	memset(&sinfo, 0x00, sizeof(STARTUPINFO));
	memset(&pinfo, 0x00, sizeof(PROCESS_INFORMATION));
	sinfo.cb = sizeof(STARTUPINFO);
	sinfo.dwFlags = STARTF_USESHOWWINDOW;
	sinfo.wShowWindow = SW_SHOWNORMAL;

	sprintf(command, "notepad.exe ");
	sprintf(ctemp, "\"%s\" ", path);
	strcat(command, ctemp);

	if (!CreateProcess(NULL, command, NULL, NULL, FALSE, NORMAL_PRIORITY_CLASS, NULL, NULL, &sinfo, &pinfo)){
		return(RTN_ERROR);
	}
	CloseHandle(pinfo.hThread);
	WaitForSingleObject(pinfo.hProcess, INFINITE);
	CloseHandle(pinfo.hProcess);

	return(RTN_NORMAL);
}

/*---------------------------------------------------------------------------*
	SpXy[Xpu
 *---------------------------------------------------------------------------*/
int	swap_mbspace(

int		charset,
unsigned char	*buffer)
{
	int		i, itemp, length;

	length = strlen((char *)buffer);
	for (i=0; i<length; i++){
		itemp = i;
		if (is_mbchar(charset, buffer[i], &itemp)){
			switch (charset){
			case	CHARSET_SJIS:	/* 8140 */
				if (buffer[i] == 0x81 && buffer[i+1] == 0x40){
					buffer[i]   = ' '; 
					buffer[i+1] = ' '; 
					i+=1;
				}
				break;
			case	CHARSET_EUC:	/* A1A1 */
				if (buffer[i] == 0xa1 && buffer[i+1] == 0xa1){
					buffer[i]   = ' '; 
					buffer[i+1] = ' '; 
					i+=1;
				}
				break;
			case	CHARSET_UTF8:	/* E38080 */
				if (buffer[i] == 0xe3 && buffer[i+1] == 0x80 && buffer[i+2] == 0x80){
					buffer[i]   = ' '; 
					buffer[i+1] = ' '; 
					buffer[i+2] = ' '; 
					i+=2;
				}
				break;
			default:
				i = itemp;
				break;
			}
		}
	}
	return(RTN_NORMAL);
}

/*---------------------------------------------------------------------------*
	dummy routine
 *---------------------------------------------------------------------------*/
int	put_errmsg(GLOBAL_PARAM *G, char *message){return 0;}

